(***********************************************************************)
(*                                                                     *)
(*            cast objet en O'Caml                                     *)
(*                                                                     *)
(*            Emmanuel Chailloux, Equipe PPS, universite P7            *)
(*                                                                     *)
(*                                                                     *)
(***********************************************************************)

(* $Id: cast.ml,v 1.2 2001/08/30 15:30:34 emmanuel Exp $ *)

type id = unit -> unit;;

exception Cast_failure of string * int * int;;

let create_id f = ((Obj.magic f):id);;

let string_of_id ( i : id) =  string_of_int (Obj.magic i);;


let instanceof (loc : int * int)  o1 (k : id) =
   ((o1#___check_id k) : bool);;

let subtypeof  (loc : int * int)  o1 (k : id) =
   ((o1#___checksubtype_id k) : bool);;





